function [a_F, v_F] = follower(v_L, v0_F, C,tau,t)
% Initialize velocity vector and accelerate vector of follower
dt = t(2) - t(1);
v_F = v0_F*ones(size(v_L));
a_F = zeros(size(v_L));

for t_step = tau:tau:t(end)-tau
    a_F(t>=t_step & t<t_step+tau) = C/tau * (v_L(t>=t_step-tau & t<t_step) - v_F(t>=t_step-tau & t<t_step));
    [v_F(t>=t_step & t<=t_step+tau), ~] = cal_v_s(a_F(t>=t_step & t<=t_step+tau), dt, v_F(t==t_step), 0);
end

