% a) Draw a graph showing the relative speed over the simulated 10 seconds.
close all; clc;
addpath('modules')

dt = 0.1;
distance = 70;
T = 20;
t = [0:dt:T]';
tau = 1;
C = 0.4;

a_L = zeros(size(t));
a_L(t>=1 & t<2) = -3;
a_L(t>=2 & t<3) = 3;

v_0_L = 20;
s_0_L = 0;
[v_L, s_L] = cal_v_s(a_L, dt, v_0_L, s_0_L);

v0_F = 30;
[a_F, v_F] = follower(v_L, v0_F, C,tau,t);
[~, s_F] = cal_v_s(a_F, dt, v0_F, s_0_L-distance);


plot(t, v_L-v_F, 'LineWidth', 2, 'Color', 'k')
xlim([0 10])
title('Relative speed ($v_{L}-v_{F}$)','Interpreter','latex')
xlabel('t [sec]','Interpreter','latex')
ylabel('v [m/s]','Interpreter','latex')
grid on