% c) What will be the distance of cars after the end of 4 and 10 sec?
close all; clc;
addpath('modules')

dt = 0.1;
distance = 70;
T = 20;
t = [0:dt:T]';
tau = 1;
C = 0.4;

a_L = zeros(size(t));
a_L(t>1 & t<=2) = -3;
a_L(t>2 & t<=3) = 3;

v_0_L = 20;
s_0_L = 0;
[v_L, s_L] = cal_v_s(a_L, dt, v_0_L, s_0_L);

v0_F = 30;
[a_F, v_F] = follower(v_L, v0_F, C,tau,t);
[~, s_F] = cal_v_s(a_F, dt, v0_F, s_0_L-distance);


d = s_L - s_F;
disp(['The distances are ', num2str(d(t == 4)), 'm at 4 seconds and ',num2str(d(t == 10))...
    , 'm at 10 seconds when the driver sensitivity C is 0.4.'])