% d) Repeat part b) and c) for C = 0.8 and C = 1.1. Comment on the results.
close all; clc;
addpath('modules')

dt = 0.1;
distance = 70;
T = 20;
t = [0:dt:T]';
tau = 1;
C = 0.4;

a_L = zeros(size(t));
a_L(t>1 & t<=2) = -3;
a_L(t>2 & t<=3) = 3;

v_0_L = 20;
s_0_L = 0;
[v_L, s_L] = cal_v_s(a_L, dt, v_0_L, s_0_L);

v0_F = 30;
[a_F, v_F] = follower(v_L, v0_F, C, tau, t);
[~, s_F] = cal_v_s(a_F, dt, v0_F, s_0_L-distance);

[a_F_08, v_F_08] = follower(v_L, v0_F, 0.8, tau, t);
[a_F_11, v_F_11] = follower(v_L, v0_F, 1.1, tau, t);
[~, s_F_08] = cal_v_s(a_F_08, dt, v0_F, s_0_L-distance);
[~, s_F_11] = cal_v_s(a_F_11, dt, v0_F, s_0_L-distance);

d_08 = s_L - s_F_08;
d_11 = s_L - s_F_11;
disp(['The distances are ', num2str(d_08(t == 4)), 'm at 4 seconds and ',num2str(d_08(t == 10))...
    , 'm at 10 seconds when the driver sensitivity C is 0.8.'])
disp(['The distances are ', num2str(d_11(t == 4)), 'm at 4 seconds and ',num2str(d_11(t == 10))...
    , 'm at 10 seconds when the driver sensitivity C is 1.1.'])

figure,
plot(t, [s_L-s_F, s_L-s_F_08, s_L-s_F_11], 'LineWidth', 2)
xlim([0 20])
xlabel('t [sec]','Interpreter','latex')
ylabel('s [m]','Interpreter','latex')
legend('L-F (C=0.4)','L-F (C=0.8)','L-F (C=1.1)')
grid on
