% e) Repeat part a) and b) for six consecutive vehicles for values of C =
% 0.5, 0.8 and 1.1, initial speed of 20m/s and initial relative distance of
% 30m for each pair. Comment on the results.
close all; clc;
addpath('modules')

dt = 0.1;
T = 20;
t = [0:dt:T]';
tau = 1;

a_L = zeros(size(t));
a_L(t>1 & t<=2) = -3;
a_L(t>2 & t<=3) = 3;

v_0_L = 20;
s_0_L = 0;
[v_L, s_L] = cal_v_s(a_L, dt, v_0_L, s_0_L);

distance = 30;
v0 = 20;
C_set = [0.5 0.8 1];
n_of_vehicles = 6;
v_L_hold = v_L; 
s_L_hold = s_L;

for C = C_set
    v_L = v_L_hold;
    s_L = s_L_hold;
    vf = figure;
    hold on
    sf = figure;
    hold on
    figure(vf)
    plot(t, v_L, 'LineWidth', 2)
    for i = 1 : n_of_vehicles - 1  
        [a_F, v_F] = follower(v_L, v0, C,tau,t);
        [~, s_F] = cal_v_s(a_F, dt, v0, s_0_L-i*distance);
        v_L = v_F;
        figure(vf)
        plot(t, v_F, 'LineWidth', 2)
        figure(sf)
        plot(t, s_L-s_F, 'LineWidth', 2)
        s_L = s_F;
    end
    figure(vf)
    xlim([0 20])
    xlabel('t [sec]','Interpreter','latex')
    ylabel('v [m/s]','Interpreter','latex')
    legend('L','F_1','F_2','F_3','F_4','F_5', 'Location', 'northwest')
    title(['C = ',num2str(C)])
    grid on
    box on
    ylim([5 35])
    hold off
    
    figure(sf)
    xlim([0 20])
    xlabel('t [sec]','Interpreter','latex')
    ylabel('s [m]','Interpreter','latex')
    legend('L-F_1','F_1-F_2','F_2-F_3','F_3-F_4','F_4-F_5', 'Location','northwest')
    title(['C = ',num2str(C)])
    grid on
    box on
    ylim([15 45])
    hold off
end